# std::destroy

From cppreference.com
< cpp‎ | memory

Defined in header `<memory>` |  |
template< class ForwardIt > void destroy( ForwardIt first, ForwardIt last ); | (1) | (since C++17)
template< class ExecutionPolicy, class ForwardIt > void destroy( ExecutionPolicy&& policy, ForwardIt first, ForwardIt last ); | (2) | (since C++17)

1) Destroys the objects in the range `[first, last)`, as if by

    for (; first != last; ++first)
      std::destroy_at(std::addressof(*first));

2) Same as (1), but executed according to `policy`. This overload does not participate in overload resolution unless std::is_execution_policy_v<std::decay_t<ExecutionPolicy>> is true.

### Parameters

first, last | - | the range of elements to destroy
policy | - | the execution policy to use. See execution policy for details.
Type requirements
- `ForwardIt` must meet the requirements of `ForwardIterator`.
- No increment, assignment, comparison, or indirection through valid instances of `ForwardIt` may throw exceptions.

### Return value

(none)

### Complexity

Linear in the distance between `first` and `last`.

### Exceptions

The overload with a template parameter named `ExecutionPolicy` reports errors as follows:

- If execution of a function invoked as part of the algorithm throws an exception and `ExecutionPolicy` is one of the three standard policies, std::terminate is called. For any other `ExecutionPolicy`, the behavior is implementation-defined.
- If the algorithm fails to allocate memory, std::bad_alloc is thrown.

### Possible implementation

    template< class ForwardIt >
    void destroy( ForwardIt first, ForwardIt last )
    {
      for (; first != last; ++first)
        std::destroy_at(std::addressof(*first));
    }

### Example

| This section is incomplete Reason: no example

### See also

destroy_n (C++17) | destroys a number of objects in a range (function template)
destroy_at (C++17) | destroys an object at a given address (function template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/memory/destroy&oldid=86819"
Category:

- Todo no example